h_modul = 800; // Höhe der Auflage für Module

gesamt_h = 3000;


unterschrank_h = h_modul + 250;
unterschrank_t = 650; // Außenmaß

oberschrank_h =  gesamt_h - unterschrank_h;
oberschrank_t = 350;
oberschrank_etagen = 5;

plexy_d = 5;

sockel_h = 70;
boden_d = 28; // Dicke der Einlegeböden
segment_l = 1000; // Länge eines Regal-Segments

module platte_unterschrank(b,t){
	color("brown") difference(){
		cube([unterschrank_t,segment_l,boden_d]);
		translate([-1,-1,-1]) cube([t+1,b+1,boden_d+2]); // Ecke 1
		translate([unterschrank_t-t+1,-1,-1]) cube([t+1,b+1,boden_d+2]); // Ecke 2
		translate([unterschrank_t-t+1,segment_l-b+1,-1]) cube([t+1,b+1,boden_d+2]); // Ecke 3
		translate([-1,segment_l-b+1,-1]) cube([t+1,b+1,boden_d+2]); // Ecke 4
	}
}


module platte_oberschrank(b,t){
	color("brown") difference(){
		cube([oberschrank_t,segment_l,boden_d]);
		translate([-1,-1,-1]) cube([t+1,b+1,boden_d+2]); // Ecke 1
		translate([oberschrank_t-t+1,-1,-1]) cube([t+1,b+1,boden_d+2]); // Ecke 2
		translate([oberschrank_t-t+1,segment_l-b+1,-1]) cube([t+1,b+1,boden_d+2]); // Ecke 3
		translate([-1,segment_l-b+1,-1]) cube([t+1,b+1,boden_d+2]); // Ecke 4
	}
}

module unterschrank_rahmen(b,h,t){
	
	translate([0,-b/2,0]){
		cube([t,b,unterschrank_h-t]); // hinterer Pfosten
		translate([unterschrank_t-t,0,0])cube([t,b,unterschrank_h-t]); // vorderer Pfosten
		color("orange")	translate([0,0,unterschrank_h-t]) cube([unterschrank_t,b,t]); // Träger
		color("orange")	translate([t,0,h_modul-h]) cube([unterschrank_t-2*t,b,h]); // obere Strebe
		color("orange")	translate([t,0,sockel_h-h]) cube([unterschrank_t-2*t,b,h]); // untere Strebe
	}
}

module oberschrank_rahmen(b,h,t){	
	translate([0,-b/2,0]){
		cube([t,b,oberschrank_h-t]); // hinterer Pfosten
		translate([oberschrank_t-t,0,0])cube([t,b,oberschrank_h-t]); // vorderer Pfosten
		step = (oberschrank_h-t) / oberschrank_etagen;
		for (e = [1:oberschrank_etagen-1]){
			color("orange")	translate([t,0,e*step-t]) cube([oberschrank_t-2*t,b,t]); // Strebe
		}
		color("orange")	translate([0,0,oberschrank_h-t]) cube([oberschrank_t,b,t]); // Träger
	}
}

module oberschrank(platten){
	b = 50; // Breite des Rahmens
	t = 30; // Tiefe der Pfosten
	h = 60; // höhe der Streben/Träger

	translate([0,0,unterschrank_h]){
		oberschrank_rahmen(b,h,t);
		if (platten) { 
			step = (oberschrank_h-t) / oberschrank_etagen;
			for (e = [0:oberschrank_etagen-1]){
				translate([0,0,step*e])platte_oberschrank(b/2,t);
			}
			translate([0,0,oberschrank_h])platte_oberschrank(0,0);
		}
	}
}


module unterschrank(platten,plexy){
	b = 50; // Breite des Rahmens
	t = 60; // Tiefe der Pfosten
	h = 60; // höhe der Streben/Träger

	unterschrank_rahmen(b,h,t);
	if (platten) { 
		translate([0,0,sockel_h])platte_unterschrank(b/2,t);
		translate([0,0,h_modul])platte_unterschrank(b/2,t);
	}
	
	if (plexy) {
		h_plexy = unterschrank_h-h_modul;
		color("cyan",0.5){
			translate([unterschrank_t-plexy_d,b/2,h_modul+boden_d])cube([plexy_d,segment_l-b,h_plexy-boden_d]);
			translate([oberschrank_t,0,unterschrank_h])cube([unterschrank_t-oberschrank_t,segment_l,plexy_d]);
		}
	}
}

module schrank(platten,plexy=true){
	unterschrank(platten,plexy);
	oberschrank(platten);
}

module eckteil(){
	d = -25;
	b = 60;
	schrank(false,false);	
	translate([unterschrank_t+d,unterschrank_t+d,0])rotate([0,0,-90])schrank(false,false);	
	translate([0,unterschrank_t-3*b/2,0])cube([b,b,gesamt_h]);
}


schrank(true,false);
translate([0,segment_l,0]) schrank(true);
translate([0,2*segment_l,0]) schrank(true);
translate([0,3*segment_l,0]) schrank(true);
translate([0,4*segment_l,0]) schrank(true);
translate([0,5*segment_l,0])eckteil();
